#!/bin/bash

echo "Content-Type: text/html"
echo
echo "<pre>"

set -e

if [ "$(id -un)" != "www-data" ]; then
        echo "run this as user www-data only" >&2
        exit 1
fi

umask 0002

cd /osgeo/download/osgeo4w/v2
exec 2>>/tmp/osgeo4w-regen-v2.log

if ! lockfile -l 600 .lock/regen.lock; then
	echo Locking failed
	exit 1
fi

trap "rm -f $PWD/.lock/regen.lock" EXIT

echo -n "start: " >&2
date >&2

cat x86_64/setup.ini >x86_64/setup.ini.prev
chmod -f -R a+r x86_64/release || true
echo -n "<font color=#ff0000>"
./genini --arch=x86_64 --recursive --output=x86_64/setup.ini.tmp x86_64/release 2>&1 | tee -a /dev/stderr && mv x86_64/setup.ini.tmp x86_64/setup.ini
echo -n "</font>"
bzip2 -c x86_64/setup.ini >x86_64/setup.ini.bz2

d=$(date +snapshots/%Y%m%d-%H%M%S/x86_64)
mkdir -p $d
cp x86_64/setup.ini x86_64/setup.ini.bz2 $d
ln -s ../../../x86_64/release $d/release

diff -u x86_64/setup.ini.prev x86_64/setup.ini | tee $d/setup.diff && echo -n "(none)" || true
echo "</pre>"

echo -n "end: " >&2
date >&2

xargs -P4 -n1 wget -O/dev/null -i - <<EOF >&2 &
https://buten.norbit.de/~jef/u/cgi-bin/mirror-osgeo4w-v2.cgi
EOF

disown -a
